<?php

/*
* Created on 01.04.2023
* HomePage: https://xentr.net
* Copyright (c) 2019-2023 XENTR | XenForo Add-ons - Styles -  All Rights Reserved
*/

namespace XENTR\Fantastic\Entity;
use XF\Mvc\Entity\Entity;
use XF\Mvc\Entity\Structure;
class Thread extends XFCP_Thread
{

	public function getNext()
	{
		$includeNode = $this->app()->options()->xentr_thread_node;  
        if(in_array($this->node_id, $includeNode) )
        {
			$nextThread = $this->getNextThread($this->post_date,$this->node_id);
	    	$previousThread = $this->getPreviousThread($this->post_date,$this->node_id);
	    	$next = [
	    		'next' => $nextThread,
	    		'previous' => $previousThread
	    	];
	    	return $next;
	    }
	    return false;
	}
	
	protected function getNextThread($postDate, $forumId)
    {
        $threadFinder = $this->finder('XF:Thread');
        $nextThread = $threadFinder
        		->where('post_date', '>', $postDate)
                ->where('node_id', $forumId) 
                ->where('discussion_state', 'visible')
                ->where('discussion_type', '<>', 'redirect')  
                ->setDefaultOrder('post_date', 'ASC')
                ->fetchOne();

        return $nextThread;    
    }

    protected function getPreviousThread($postDate, $forumId)
    {
        $threadFinder = $this->finder('XF:Thread');
        $nextThread = $threadFinder
        		->where('post_date', '<', $postDate)
                ->where('node_id', $forumId) 
                ->where('discussion_state', 'visible')
                ->where('discussion_type', '<>', 'redirect')  
                ->setDefaultOrder('post_date', 'DESC')
                ->fetchOne();

        return $nextThread;    
    }

    public static function getStructure(Structure $structure)
    {
        $structure = parent::getStructure($structure);
        $structure->getters['next'] = true;
        return $structure;
    }
}